do
    local Prefs = import('/lua/user/prefs.lua')
    local options = Prefs.GetFromCurrentProfile('options')


    --visible template names
    if options.gui_visible_template_names != 0 then
        local cutA = 0
        local cutB = 0
        if options.gui_template_name_cutoff != nil then
            cutA = options.gui_template_name_cutoff
            cutB = options.gui_template_name_cutoff
        end
        cutA = cutA + 1
        cutB = cutB + 7

        local oldCommonLogic = CommonLogic
        function CommonLogic()
            oldCommonLogic()
            local oldSecondary = controls.secondaryChoices.SetControlToType
            local oldPrimary = controls.choices.SetControlToType
            local oldPrimaryCreate = controls.choices.CreateElement
            controls.choices.CreateElement = function()
                local btn = oldPrimaryCreate()
-- creating the display area
                btn.Tmplnm = UIUtil.CreateText(btn.Icon, '', 11, UIUtil.bodyFont)
                btn.Tmplnm:SetColor('ffffff00')
                btn.Tmplnm:DisableHitTest()
                btn.Tmplnm:SetDropShadow(true)
                btn.Tmplnm:SetCenteredHorizontally(true)
                LayoutHelpers.CenteredBelow(btn.Tmplnm, btn, 0)
                btn.Tmplnm.Depth:Set(function() return btn.Icon.Depth() + 10 end)
                return btn
            end
            controls.secondaryChoices.SetControlToType = function(control, type)
                oldSecondary(control, type)
            end
            controls.choices.SetControlToType = function(control, type)
                oldPrimary(control, type)
-- the text
                if type == 'templates' and 'templates' then
                    control.Tmplnm.Width:Set(48)
                    control.Tmplnm:SetText(string.sub(control.Data.template.name, cutA, cutB))
                end
            end
        end
    end

    --Improved unit deselection
    if options.gui_improved_unit_deselection != 0 then
        local oldOnClickHandler = OnClickHandler
        function OnClickHandler(button, modifiers)
            local item = button.Data
            if item.type == 'unitstack' then
                if modifiers.Right then
                    if modifiers.Shift or modifiers.Ctrl or (modifiers.Shift and modifiers.Ctrl) then -- we have one of our modifiers
                        local selectionx = {}
                        local countx = 0
                        if modifiers.Shift then countx = 1 end 
                        if modifiers.Ctrl then countx = 5 end
                        if modifiers.Shift and modifiers.Ctrl then countx = 10 end
                        for _, unit in sortedOptions.selection do
                            local foundx = false
                            for _, checkUnit in item.units do
                                if checkUnit == unit and countx > 0 then
                                    foundx = true
                                    countx = countx - 1
                                    break
                                end
                            end
                            if not foundx then
                                table.insert(selectionx, unit)
                            end
                        end
                        SelectUnits(selectionx)
                    else -- default right-click behavior
                        local selection = {}
                        for _, unit in sortedOptions.selection do
                            local found = false
                            for _, checkUnit in item.units do
                                if checkUnit == unit then
                                    found = true
                                    break
                                end
                            end
                            if not found then
                                table.insert(selection, unit)
                            end
                        end
                        SelectUnits(selection)
                    end
                end
                -- override default rightclick handler
                if modifiers.Right then return end
                -- else new code does not work as intended
            end
            oldOnClickHandler(button, modifiers)
        end
    end


end --eof